#include "tty.h"
#include "gpio.h"
#include "usb/cdc-acm.h"
#include "usb/cusb.h"
#include "utils.h"
#include "addrmap.h"


void tty_init(void){
  usb_cdc_acm_init();
}

char tty_getchar(void){
  char c;
  usb_cdc_acm_recv(&c, 1);
  return c;
}

void tty_putchar(char c){
  char str[2]="";
  str[0]=c;
  usb_cdc_acm_send(str, 2);
}

void tty_putstr(char *str){
  usb_cdc_acm_send(str, strlen(str)+1);
}
